using System;
using System.Windows.Forms;
/*
	Komponentin lisminen orrelle:
		Valitse menusta Component->Installed .NET Components
		Paina Select Assembly -nappia, vaiha assemblyn tyypiksi .exe
		etsi autol.exe

	Todo: kyttliittym timerille
*/
namespace Autol
{

	/// <summary>
	/// Tapahtumaluokka laskurin onChange-tapahtumalle
	/// </summary>
	public class ChangeEvent : EventArgs {
		private int diff;

		public ChangeEvent(int diff) {
			this.diff = diff;
		}

		public int getDiff() {
			return diff;
		}

	}

	// Metodiosoitinolio tapahtumanksittelijit varten
	public delegate void ChangeEventHandler(Object sender,ChangeEvent e);

	/// <summary>
	/// Laskuri jossa count-ominaisuus
	/// Vesa Lappalainen, 23.11.2003
	/// Laajennettu tapahtumilla
    /// Miika Nurminen, 17.9.2004
	/// </summary>
	public class Laskuri : System.Windows.Forms.Label {
		private int countVal=0;

		public event ChangeEventHandler change;

		// base kutsuu yliluokan konstruktoria
		public Laskuri() : base() {
			InitializeComponent();
			reset();
		}

		protected virtual void OnChange(ChangeEvent e) {
			// kutsutaan tapahtumaksittelijit, jos niit on
			if (change!=null) change(this,e);
		}

		public int count {
			get {
//				return Convert.ToInt32(Text);
				return countVal;
			}
			set {
				int diff = value-countVal;
				// kutsutaan yliluokan text-propertya, ettei tule rekursiota
				base.Text = "" + value;
				countVal = value;
				// Luodaan muutostapahtuma
				OnChange(new ChangeEvent(diff));
			}
		}

		// Syrjytetn Label-luokan text-property
		public override string Text {
			get { return base.Text; }
			set {
				try {
					int i = Convert.ToInt32(value);
					count = i;
				}
				catch (Exception e) {
					count = 0;
				}
			}
		}

		public void reset() {
			count = 0;
		}


		/// <summary>
		/// Kustomoitu OnClick - varmistaa, ett laskuri lisntyy,
		/// kun laskuria painetaan.
		/// (toinen vaihtoehto olisi ollut list tapahtumaksittelij
		///  suoraan komponentin sislle)
		/// </summary>
		protected override void OnClick(EventArgs e) {
			base.OnClick(e); // kutsuu yliluokan OnClick-metodia
			this.count+=1;
		}

		private void InitializeComponent()
		{
			// 
			// Laskuri
			// 
			this.BackColor = System.Drawing.Color.Aqua;
			this.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
			this.Font = new System.Drawing.Font("Microsoft Sans Serif", 10F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
			this.Text = "0";
			this.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
		}

	}
}
