using System;

namespace stream
{
	/// <summary>
	/// Esimerkki tietovirtojen kytst ja filttereist
	/// </summary>
	/// <remarks> Miika Nurminen, 16.9.2004</remarks>
	class StreamSystem
	{
		private System.IO.TextReader inStream;
		private System.IO.TextWriter outStream;
		private Filter action;

		StreamSystem(System.IO.TextReader istr,System.IO.TextWriter os, Filter act) {
			inStream = istr;
			outStream = os;
			action = act;
		}

		private void writeOut(string s) {
			if (s==null) return;
			outStream.WriteLine(s);
		}
		/// <summary>
		/// Lukee sytevirtaa loppuun tai tyhjn riviin asti
		/// Jos toiminto on NULL, kaiutetaan
		/// </summary>
		void run() {
			string s;
			string t = null;
			try {
				while (true) {
					s = inStream.ReadLine();
					if ((s==null) || (s.Equals(""))) break;
					if (action==null) t = s;
					else t = action.processLine(s);
					writeOut(t);
				}
				if (action!=null) t = action.getResult();
				writeOut(t);
			}
			catch (Exception e) {
				Console.Error.WriteLine(e.Message);
			}
		}

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main(string[] args)
		{
			try {
				Console.Out.WriteLine("Hello world!");

				// tiedostot
//				System.IO.TextReader inFile = new System.IO.StreamReader("input.txt");
				System.IO.TextWriter outFile = new System.IO.StreamWriter("out.txt");
				StreamSystem s = null;

			// testi: kaiutus ruutuun ilman filtteri
	//			s = new StreamSystem(Console.In,Console.Out, null);

			// kaiutus tiedostoon
//				s = new StreamSystem(Console.In,outFile, new EchoFilter());

			// summaus tiedostosta
//				s = new StreamSystem(inFile,Console.Out, new Summaaja());

				Lukija luk = new Lukija(0);
				System.IO.TextReader inFile = new System.IO.StreamReader("fields.txt");
				s = new StreamSystem(inFile,Console.Out,luk);

				s.run();

				Console.Out.WriteLine(luk.sumByField(2));

				luk.sortByField(1);
	  			Console.Out.WriteLine(luk);

				// Suljetaan tiedostovirrat kytn jlkeen
				inFile.Close();
				outFile.Close();
			}
			// huono pikaratkaisu kaikkien poikkeusten ksittelyyn..s.
			catch (Exception e) {
				Console.Error.WriteLine(e.Message);	
			}
		}
	}
}
